"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var contribution_1 = require("./contribution");
var validUsername = 'jamieweavis';
var invalidUsername = 'veryveryveryveryveryverylonginvalidusername';
var responseShape = {
    streak: {
        best: expect.any(Number),
        current: expect.any(Number),
    },
    contributions: {
        best: expect.any(Number),
        current: expect.any(Number),
        total: expect.any(Number),
    },
};
var errorShape = {
    statusCode: expect.any(Number),
};
describe('contribution', function () {
    describe('the fetchStats function', function () {
        describe('when provided with a valid username', function () {
            it('should execute the success callback with contribution data', function (done) {
                (0, contribution_1.fetchStats)(validUsername, {
                    onSuccess: function (stats) {
                        expect(stats).toEqual(expect.objectContaining(responseShape));
                        done();
                    },
                });
            });
            it('should resolve a promise with contribution data', function (done) {
                (0, contribution_1.fetchStats)(validUsername).then(function (data) {
                    expect(data).toEqual(expect.objectContaining(responseShape));
                    done();
                });
            });
            it('should await with contribution data', function (done) { return __awaiter(void 0, void 0, void 0, function () {
                var data;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, (0, contribution_1.fetchStats)(validUsername)];
                        case 1:
                            data = _a.sent();
                            expect(data).toEqual(expect.objectContaining(responseShape));
                            done();
                            return [2 /*return*/];
                    }
                });
            }); });
        });
        describe('when provided with an invalid username', function () {
            it('should execute the failure callback with error message', function (done) {
                (0, contribution_1.fetchStats)(invalidUsername, {
                    onFailure: function (error) {
                        expect(error).toEqual(expect.objectContaining(errorShape));
                        done();
                    },
                });
            });
            it('should catch the promise rejection with error message', function (done) {
                (0, contribution_1.fetchStats)(invalidUsername).catch(function (error) {
                    expect(error).toEqual(expect.objectContaining(errorShape));
                    done();
                });
            });
            it('should catch the error with error message', function (done) { return __awaiter(void 0, void 0, void 0, function () {
                var error_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, (0, contribution_1.fetchStats)(invalidUsername)];
                        case 1:
                            _a.sent();
                            return [3 /*break*/, 3];
                        case 2:
                            error_1 = _a.sent();
                            expect(error_1).toEqual(expect.objectContaining(errorShape));
                            done();
                            return [3 /*break*/, 3];
                        case 3: return [2 /*return*/];
                    }
                });
            }); });
        });
        describe('when called twice', function () {
            it('should return the same value twice (be idempotent)', function (done) { return __awaiter(void 0, void 0, void 0, function () {
                var first, second;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, (0, contribution_1.fetchStats)(validUsername)];
                        case 1:
                            first = _a.sent();
                            return [4 /*yield*/, (0, contribution_1.fetchStats)(validUsername)];
                        case 2:
                            second = _a.sent();
                            expect(first).toEqual(expect.objectContaining(responseShape));
                            expect(second).toEqual(expect.objectContaining(responseShape));
                            done();
                            return [2 /*return*/];
                    }
                });
            }); });
        });
    });
});
